package cn.ibizlab.assetmanagement.core.apply.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.apply.domain.EAMApply;
import cn.ibizlab.assetmanagement.core.apply.filter.EAMApplySearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMApply] 服务对象接口
 */
public interface IEAMApplyService extends IService<EAMApply>{

    boolean create(EAMApply et) ;
    void createBatch(List<EAMApply> list) ;
    boolean update(EAMApply et) ;
    void updateBatch(List<EAMApply> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMApply get(String key) ;
    EAMApply getDraft(EAMApply et) ;
    boolean checkKey(EAMApply et) ;
    boolean save(EAMApply et) ;
    void saveBatch(List<EAMApply> list) ;
    Page<EAMApply> searchDefault(EAMApplySearchContext context) ;
    List<EAMApply> selectByEamapplytypeid(String eamapplytypeid) ;
    void removeByEamapplytypeid(String eamapplytypeid) ;
    List<EAMApply> selectByAssetid(String assetid) ;
    void removeByAssetid(String assetid) ;
    List<EAMApply> selectByEamlocationid(String eamlocationid) ;
    void removeByEamlocationid(String eamlocationid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMApply> getEamapplyByIds(List<String> ids) ;
    List<EAMApply> getEamapplyByEntities(List<EAMApply> entities) ;
}


